Subject: Re: bug#2058: 23.0.60; bewildering behavior when visit new file throw.pdf

From: Tassilo Horn <[email-masked]>
Date: Tue, 27 Jan 2009 15:46:59 +0100

Alan Mackenzie <[email-masked]> writes:

Hi Alan,

>> But how should I know that.  The best I can do is to handle
>> non-existing and empty files.
>
> Does an empty/non-existent file have any meaning in this mode?

No, they'll break it as Drew pointed out.

> Is doc-view-mode an editing mode as well as a viewing mode?

Only viewing, although you can toggle between viewing in doc-view-mode
and editing (fundamental-mode or ps-mode with doc-view-minor-mode) with
C-c C-c.

>> > What on earth is doc-view-mode?  Hmm.  C-h f doc-view-mode <CR>.  ;-(
>
>> Emacs 23.
>
> Yes, I know.  :-)  I was looking at the doc string in doc-view.el from
> 2009-01-05.  Here's the output from that C-h f:
>
>     doc-view-mode is an interactive autoloaded Lisp function in
>     `doc-view.el'.
>
>     (doc-view-mode)
>
>     Major mode in DocView buffers.
>     You can use
>     Uses keymap "doc-view-mode-map", which is not currently defined.
>     M-x doc-view-toggle-display to
>     toggle between displaying the document or editing it as text.
>
>     Uses keymap "doc-view-mode-map", which is not currently defined.
>
> It doesn't work well before the `doc-view-mode-map' keymap is loaded.
> But mainly, it doesn't say at all what doc-view-mode is for.  Could you
> maybe put something about the mode's purpose into the doc string?
> Possibly this comment from doc-view.el:
>
>     ;; DocView is a document viewer for Emacs.  It converts PDF, PS and DVI files
>     ;; to a set of PNG files, one PNG for each page, and displays the PNG images
>     ;; inside an Emacs buffer.  This buffer uses `doc-view-mode' which provides
>     ;; convenient key bindings for browsing the document.
>
> , or more succinctly:
>
>     Doc View Mode is an Emacs document viewer.  It displays PDF, PS and
>     DVI files (as PNG images) in Emacs buffers.

Yes, I'll fix that.  The current doc-string is really awful. ;-)

>> >> Sure.  So what's your advice how to handle this situation?  Check if
>> >> the file is existent (and non-empty) and if not, print a message and
>> >> fallback to fundamental mode?
>
>> > Whatever is done, don't force the poor bewildered user to make a
>> > decision.  Perform whatever error handling is appropriate and display
>> > a message, and let her get out without further ado.
>
>> The message is no problem, but what to do with the open request.  Open
>> the (presumably) mistyped file in fundamental-mode?
>
> That's more or less what the .gzip mode (can't remember it's exact name)
> does - it displays the raw unintelligible file.

Ok, I will make it so.

>> > "... to switch to an editing mode " is particularly bad.  It should be
>> > less vague, stating the mode (text mode?).
>
>> Well, it's ps-mode for PostScript files and fundamental-mode for PDF and
>> DVI files.  Making that explicit would enlarge the message even more...
>
> Er, "... to switch to ps-mode" and "... to switch to fundamental mode"
> are shorter.  Surely you can determine the exact prompt at run time?

Thanks for your confidence in me.  But yes, it can be done easily. ;-)

> Bis später!

Jawollja!